/**
 * 
 */
var mX=0,mY=0;

var statements=[];
var divHoveringIndex=-1;
var divSrcIndex=-1;
var divDestinationIndex=-1;
var xOffset=0;
var yOffset=0;
var slotHeight=0;
var originalStatementLeft=0;
var originalStatementTop=0;
var correctIndex=0;
var wrongIndex=0;

var effectRunning=false;

function initialise(){
    var leftBorder=5;
    showAppTitle();

    initialiseEvents();
    showPrompt();

    codeLeftBorder=$(document).width()/2+verticalBorder;
    codeTopBorder=$(document).height()/2;
    listIntegerLeft=leftBorder;
    listIntegerTop=$("#mainArea").position().top;
    listRealLeft=$(document).width()/4+leftBorder;
    listRealTop=listIntegerTop;
    listCharacterLeft=$(document).width()/2+leftBorder;
    listCharacterTop=listIntegerTop;
    listBooleanLeft=3*$(document).width()/4+leftBorder;
    listBooleanTop=listIntegerTop;
    defineMovablesArray();
    generateNewValue();
    placeDIVs();
    initialiseEvents();
}

function initialiseEvents(){
    // mouse events
    document.addEventListener("mousedown",function(evt){
        handleMouseDown();
    });

    document.addEventListener("mouseup",function(evt){
        evt.stopImmediatePropagation();
        mX=evt.pageX;
        mY=evt.pageY;
        handleMouseUp();
    });
    document.addEventListener("mousemove",function(evt){
        mX=evt.pageX;
        mY=evt.pageY;
        handleMouseMove();
    });

    // touch events
    $("#showInfo").on("touchend",function(evt){
        $("#showInfo").trigger("click");
    });

    $("#list0").on("click tap touchstart touchend",function(evt){
        $(".itemToExplain").removeClass("itemToExplain");
        if(evt.target.id!="list0"){
            handleTappedList(evt.target.id);
        }
        else{
            placeInList(integerListIndex);
        }
        evt.preventDefault();
        evt.stopImmediatePropagation();
    });

    $("#list1").on("click tap touchstart touchend",function(evt){
        $(".itemToExplain").removeClass("itemToExplain");
        if(evt.target.id!="list1"){
            handleTappedList(evt.target.id);
        }
        else{
            placeInList(realListIndex);
        }
        evt.preventDefault();
        evt.stopImmediatePropagation();
    });

    $("#list2").on("click tap touchstart touchend",function(evt){
        $(".itemToExplain").removeClass("itemToExplain");
        if(evt.target.id!="list2"){
            handleTappedList(evt.target.id);
        }
        else{
            placeInList(characterListIndex);
        }
        evt.preventDefault();
        evt.stopImmediatePropagation();
    });
    
    $("#list3").on("click tap touchstart touchend",function(evt){
        $(".itemToExplain").removeClass("itemToExplain");
        if(evt.target.id!="list3"){
            handleTappedList(evt.target.id);
        }
        else{
            placeInList(booleanListIndex);
        }
        evt.preventDefault();
        evt.stopImmediatePropagation();
    });
    
    $("#assignmentToCheck0").on("touchend",function(evt){
        evt.preventDefault();
        evt.stopImmediatePropagation();
        $(".itemToExplain").removeClass("itemToExplain");

        $("#list"+integerListIndex).css({
            "background-color":"#ffffff"
        });
        $("#list"+realListIndex).css({
            "background-color":"#ffffff"
        });
        $("#list"+characterListIndex).css({
            "background-color":"#ffffff"
        });
        $("#list"+booleanListIndex).css({
            "background-color":"#ffffff"
        });
        divSrcIndex=0;
        $("#"+statements[divSrcIndex].htmlID).addClass("tapped");
    });

    /*
     * document.addEventListener("touchstart",function(evt){ handleMouseDown(); }, false);
     */

    /*
     * document.addEventListener("touchmove",function(evt){ //evt.preventDefault(); mX=evt.changedTouches[0].pageX; mY=evt.changedTouches[0].pageY; handleMouseMove(); }, false);
     */
}

function handleTappedList(targetID){
    $("#"+targetID).addClass("itemToExplain");
    var param=$("#"+targetID).attr("data-expl");
    showExplanation(param);

    /*
     * statements[divSrcIndex].release(); divDestinationIndex=listIndex; $("#list"+divDestinationIndex).css({"background-color": listBackcolorOnHover}); $.each($(".tapped"),function(){ $(this).removeClass("tapped"); }); handleMouseUp();
     */
}

function placeInList(selectedListIndex){
    if(divSrcIndex>-1){// έλεγχος σημείου απόθεσης
        statements[divSrcIndex].release();
        divDestinationIndex=selectedListIndex;
        $("#list"+divDestinationIndex).css({
            "background-color":listBackcolorOnHover
        });
        $.each($(".tapped"),function(){
            $(this).removeClass("tapped");
        });

        handleMouseUp();
    }
}

function handleMouseDown(){
    if(effectRunning)
        return;
    if(divHoveringIndex>-1){
        divSrcIndex=parseInt(divHoveringIndex);
        xOffset=statements[divSrcIndex].left-mX;
        yOffset=statements[divSrcIndex].top-mY;
        statements[divSrcIndex].grab();
    }
}

function handleMouseUp(){
    if(effectRunning)
        return;
    if(divSrcIndex>-1){
        statements[divSrcIndex].release();
        // 1. Αν ο χρήστης αποθέτει το statement εκτός των λιστών, επιστροφή στην αρχική θέση
        if(divDestinationIndex==-1){
            divHoveringIndex=-1;
            divSrcIndex=-1;
            divDestinationIndex=-1;
            showStatements();
        }
        // 2. αλλιώς τοποθέτηση σε επιλεγμένη λίστα
        else{
            var newClass="categorisationOk";
            correctIndex++;
            var itemIndex="c"+correctIndex;
            var explanationTitle="Σωστή κατηγοριοποίηση";
            if(divDestinationIndex!=currentValue){
                correctIndex--;
                wrongIndex++;
                itemIndex="w"+wrongIndex;
                newClass="categorisationError";
                explanationTitle="Λανθασμένη κατηγοριοποίηση";
            }
            var itemToAdd=$("#assignmentToCategorise").html();
            $("#assignmentToCategorise").html("");
            var explanation="<span class=\""+newClass+"\">"+explanationTitle+":</span><br>"+$("#assignmentToCategorise").attr("data-explanation");
            var htmlToAdd="<code class='"+newClass+"' id='"+itemIndex+"' data-expl='"+explanation+"'>"+itemToAdd+"</code><br>";
            var currentList=$("#list"+divDestinationIndex).html();
            effectRunning=true;
            $("#"+statements[0].htmlID).animate({
                width:0,
                height:0,
                opacity:0
            },{
                duration:animationRate,
                complete:function(){
                    completeEffect(htmlToAdd+currentList);
                }
            });
        }
    }
    showListPrompt();
}

function completeEffect(newHTML){
    $("#list"+divDestinationIndex).html(newHTML);
    scoreToShow=calculateScore(divDestinationIndex);
    $("#score"+divDestinationIndex).html(scoreToShow);
    divHoveringIndex=-1;
    divSrcIndex=-1;
    divDestinationIndex=-1;
    generatorCounter++;
    if(generatorCounter % 15 == 0){
        currentNoOfOperands=Math.min(currentNoOfOperands+1,maxNoOfOperands);
    }
    generateNewValue();
    $("#"+statements[0].htmlID).animate({
        left:0,
        top:originalStatementTop,
        width:0,
        height:0,
        opacity:1
    },{
        complete:function(){
            showStatements();
            $("#list"+integerListIndex).css({
                "background-color":"#ffffff"
            });
            $("#list"+realListIndex).css({
                "background-color":"#ffffff"
            });
            $("#list"+characterListIndex).css({
                "background-color":"#ffffff"
            });
            $("#list"+booleanListIndex).css({
                "background-color":"#ffffff"
            });
            $(".itemToExplain").removeClass("itemToExplain");

            effectRunning=false;
        }
    });
}

function calculateScore(selectedList){
    var correctEntries=$("#list"+selectedList+" .categorisationOk").length;
    var totalEntries=correctEntries+$("#list"+selectedList+" .categorisationError").length;
    var percentage=parseInt(1000*correctEntries/totalEntries)/10;
    return ": "+correctEntries+"/"+totalEntries+" ("+percentage+"%)";

}

function showListPrompt(){
    if(correctIndex+wrongIndex>0){
        $("#explain").html("Επιλέξτε μια καταχώρηση από τις λίστες για επεξήγηση της κατηγοριοποίησης.");
    }
}

function handleMouseMove(){
    if(effectRunning)
        return;
    var i=0;
    divDestinationIndex=-1;
    $("#list"+integerListIndex).css({
        "background-color":"#ffffff"
    });
    $("#list"+realListIndex).css({
        "background-color":"#ffffff"
    });
    $("#list"+characterListIndex).css({
        "background-color":"#ffffff"
    });
    $("#list"+booleanListIndex).css({
        "background-color":"#ffffff"
    });
    if(mouseInsideList("list"+integerListIndex)){
        divDestinationIndex=integerListIndex;
        $("#list"+integerListIndex).css({
            "background-color":listBackcolorOnHover
        });
    }
    else if(mouseInsideList("list"+realListIndex)){
        $("#list"+realListIndex).css({
            "background-color":listBackcolorOnHover
        });
        divDestinationIndex=realListIndex;
    }
    else if(mouseInsideList("list"+characterListIndex)){
        $("#list"+characterListIndex).css({
            "background-color":listBackcolorOnHover
        });
        divDestinationIndex=characterListIndex;
    }
    else if(mouseInsideList("list"+booleanListIndex)){
        $("#list"+booleanListIndex).css({
            "background-color":listBackcolorOnHover
        });
        divDestinationIndex=booleanListIndex;
    }
    if(divSrcIndex>-1){// μετατόπιση επιλεγμένου DIV
        updateMovingDIV(statements[divSrcIndex]);
    }
    else{// έλεγχος θέσης ποντικιού ως προς τα DIVs (hovering)
        divHoveringIndex=-1;
        i=0;
        while(i<statements.length&&divHoveringIndex==-1){
            if(statements[i].mouseHover(mX,mY)){
                xOffset=statements[i].left-mX;
                yOffset=statements[i].top-mY;
                divHoveringIndex=i;
            }
            else{
                i++;
            }
        }
    }
    if(debugMode)
        document.getElementById("debug").innerHTML="mX="+mX+" mY="+mY+" HoverIndex="+divHoveringIndex+" SourceIndex="+divSrcIndex+" DestinationIndex="+divDestinationIndex;
}

function mouseInsideList(selectedListId){
    var listLeft=$("#"+selectedListId).offset().left;
    var listRight=listLeft+$("#"+selectedListId).width();
    var listTop=$("#"+selectedListId).offset().top;
    var listBottom=listTop+$("#"+selectedListId).height();
    var insideList=mX>listLeft;
    insideList=insideList&&mX<listRight;
    insideList=insideList&&mY>listTop;
    insideList=insideList&&mY<listBottom;
    return insideList;
}

function handleMouseOut(){
    if(effectRunning)
        return;
    divHoveringIndex=-1;
}

function showExplanation(explanation){
    $("#explain").html(explanation);
}

function updateMovingDIV(statementOnTheMove){
    statementOnTheMove.move(mX+xOffset,mY+yOffset);
}

function defineMovablesArray(){
    var page=0,col=0,row=0;
    $.each($(".movableDIV"),function(){
        var height=parseInt($(this).outerHeight());
        slotHeight=Math.max(slotHeight,height);
    });
    var i=0;
    $.each($(".movableDIV"),function(){
        var htmlID=$(this).attr("id");
        originalStatementLeft=($(document).width()-$("#assignmentToCheck0").width())/2;
        originalStatementTop=$("#assignmentToCheck0").position().top;
        var width=$("#assignmentToCheck0").width();
        var newStatement=new statement(htmlID,codeLeftBorder,codeTopBorder,originalStatementLeft,originalStatementTop,row,col,width,slotHeight,page,animationRate);
        statements.push(newStatement);
        row++;
        i++;
    });
    placeDIVs();
}

function generateNewValue(){
    var newValue="";
    var explanation="";
    do{
        currentValue=parseInt(Math.random()*4);
    }while(currentValue==previousValue);
    previousValue=currentValue;
    switch(currentValue){
        case integerValue:
            newValue=generateArithmeticExpression(100,1,noOfArithmeticOperators,noOfIntegerFunctions);
            explanation="Μια αριθμητική έκφραση χωρίς δεκαδικά ψηφία θεωρείται ακέραια.";
            break;
        case realValue:
            newValue=generateArithmeticExpression(1000,10,noOfRealArithmeticOperators,noOfFunctions);
            explanation="Μια αριθμητική έκφραση με δεκαδικά ψηφία θεωρείται πραγματική.";
            break;
        case characterValue:
            var stringExpressionSelector=Math.random();
            if(stringExpressionSelector<0.1){
                newValue=generateArithmeticExpression(100,1,noOfArithmeticOperators,noOfIntegerFunctions);
            }
            else if(stringExpressionSelector<0.2){
                newValue=generateArithmeticExpression(1000,10,noOfRealArithmeticOperators,noOfFunctions);
            }
            else{
                newValue=generateExpression("").newVal;
            }
            newValue="\""+newValue+"\"";
            explanation="Οποιαδήποτε έκφραση περικλείεται σε εισαγωγικά θεωρείται τύπου χαρακτήρων.";
            break;
        case booleanValue:
            var result=generateExpression("\"");
            newValue=result.newVal;
            explanation=result.expl;
            break;
    }
    $("#assignmentToCategorise").html(newValue);
    $("#assignmentToCategorise").attr("data-explanation",explanation);
}

function generateExpression(quotationMarks){
    var mainSelector=Math.random();
    var explanation="Λογική Σταθερά";
    var newValue="";
    if(mainSelector>0.9){
        newValue="ΑΛΗΘΗΣ";
    }
    else if(mainSelector>0.8){
        newValue="ΨΕΥΔΗΣ";
    }
    else{
        var selectedComparator=comparators[parseInt(Math.random()*comparators.length)];
        var secondarySelector=Math.random();
        var valueIndex=0;
        if(secondarySelector>0.8){
            valueIndex=parseInt(Math.random()*(headerVars.length-1))+1;
            newValue=headerVars[0]+selectedComparator+quotationMarks+headerVars[valueIndex]+quotationMarks;
        }
        else if(secondarySelector>0.6){
            valueIndex=parseInt(Math.random()*(titleVars.length-1))+1;
            newValue=titleVars[0]+selectedComparator+quotationMarks+titleVars[valueIndex]+quotationMarks;
        }
        else if(secondarySelector>0.4){
            valueIndex=parseInt(Math.random()*(givenNamesVars.length-1))+1;
            newValue=givenNamesVars[0]+selectedComparator+quotationMarks+givenNamesVars[valueIndex]+quotationMarks;
        }
        else if(secondarySelector>0.2){
            valueIndex=parseInt(Math.random()*(surnamesVars.length-1))+1;
            newValue=surnamesVars[0]+selectedComparator+quotationMarks+givenNamesVars[valueIndex]+quotationMarks;
        }
        else{
            var constantVal=0;
            valueIndex=parseInt(Math.random()*arithmeticVars.length);
            if(valueIndex<3){
                constantVal=(parseInt(Math.random()*99)+1)/4;// το πολύ 0.25
            }
            else if(valueIndex<6){
                constantVal=parseInt(Math.random()*100000)/100;// πραγματικός με 3 ακέραια και δύο δεκαδικά ψηφία
            }
            else if(valueIndex<13){
                constantVal=parseInt(Math.random()*9900)+100;// ακέραιος με 2-4 ψηφία
            }
            else{
                constantVal=parseInt(Math.random()*100);// ακέραιος με 1-2 ψηφία
            }
            newValue=arithmeticVars[valueIndex]+selectedComparator+constantVal;
        }
        explanation="Μια έκφραση που περιλαμβάνει συγκριτικούς τελεστές θεωρείται λογική.";
    }
    return {
        newVal: newValue,
        expl: explanation
    };
}

function generateArithmeticExpression(factor1,factor2,permittedOperators,permittedFunctions){
    var selector=0;
    var newValue="";
    var operatorToExclude="";
    var randomNo=0;
    if(permittedOperators==noOfArithmeticOperators){//αν επιτρέπονται οι div, mod, τότε εξαιρείται ο /
        operatorToExclude="/";
    }
    var multiplicity=parseInt(Math.random()*currentNoOfOperands)+1;//το πολύ 4 ορίσματα
    for(var i=0;i<multiplicity;i++){
        var includeFunction=Math.random()>0.8;//20% πιθανότητα να χρησιμοποιηθεί συνάρτηση
        if(includeFunction){
            selector=parseInt(Math.random()*permittedFunctions);
            newValue+=functions[selector]+"(";
        }
        var sign=1;
        if(Math.random()<0.5 && selector!=sqrtIndex && selector!=lnIndex){//αποκλεισμός αρνητικού ορίσματος σε ρίζα / λογάριθμο
            sign=-1;//50% πιθανότητα ο αριθμός να είναι αρνητικός
            if(newValue.substr(newValue.length-1,1)!=" " && i>0 && !includeFunction){
                newValue=newValue.substr(0,newValue.length-1);
            }
        }
        do{
            //παραγωγή αριθμού
            if(includeFunction){
                do{
                    randomNo=parseInt(Math.random()*factor1);
                }while(randomNo % 10 != 0 && Math.random()<0.2);//Πιθανότητα 80% για τιμές που λήγουν σε 0, όταν πρόκειται για  όρισμα συνάρτησης
            }
            else{
                do{
                    randomNo=parseInt(Math.random()*factor1);
                }while(randomNo % 10 == 0);//αποκλεισμός τιμών που λήγουν σε 0
            }
            randomNo=randomNo/factor2;
        }while(selector==lnIndex && randomNo==0);//αποκλεισμός μηδενικού ορίσματος σε λογάριθμο
        newValue+=sign*randomNo;
        if(includeFunction){
            newValue+=")";
        }
        if(i<multiplicity-1){
            do{//παραγωγή αριθμητικού τελεστή
                selector=parseInt(Math.random()*permittedOperators);
            }while(arithmeticOperators[selector]==operatorToExclude);
            newValue+=arithmeticOperators[selector];
        }
    }
    return newValue;
}

function placeDIVs(){
    $("#integerValues").css({
        left:listIntegerLeft,
        top:listIntegerTop
    });
    $("#integerValues").width(0.24*$(document).width());

    $("#realValues").css({
        left:listRealLeft,
        top:listRealTop
    });
    $("#realValues").width(0.24*$(document).width());

    $("#characterValues").css({
        left:listCharacterLeft,
        top:listCharacterTop
    });
    $("#characterValues").width(0.24*$(document).width());

    $("#booleanValues").css({
        left:listBooleanLeft,
        top:listBooleanTop
    });
    $("#booleanValues").width(0.24*$(document).width());
    showStatements();
}

function showStatements(){
    for( var i=0;i<statements.length;i++){
        $("#assignmentToCheck"+i).show();
        statements[i].move(originalStatementLeft,originalStatementTop);
    }
}

function showPrompt(){
    var msg="Τοποθέτησε την ακόλουθη έκφραση στη λίστα που αντιστοιχεί στον τύπο της.";
    $("#prompt").html(msg);
}